import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.AffineTransform;
import java.awt.Polygon;

/**
 * Ein Polygon - Transformation - Test.
 * Es werden jeweils die Originalfigur und die transformierte angezeigt.
 * @author  claus albowski
 */
public class PolygonTransformation extends Moebel
{
   Shape polygon;
   AffineTransform aktuelleTransformation;
  /**
   * Erzeuge ein neues Polygon.
   */
    public PolygonTransformation()
  {
    xPosition = 100;
    yPosition = 100;
    farbe = "blau";
    orientierung = 0;
    istSichtbar = false;
    breite = 100;
    tiefe  = 50;
    aktuelleTransformation = new AffineTransform();
  }  
  
  /**
   * Berechnet das zu zeichnende Shape anhand der gegebenen Daten
   */
  protected Shape gibAktuelleFigur()
  {
      GeneralPath originalUndBild = new GeneralPath();
      int[] xKoordinaten = { 0, breite/2, breite, breite, 0} ;
      int[] yKoordinaten = { 0, tiefe/3, tiefe/3, tiefe, tiefe} ;
      polygon = new Polygon(xKoordinaten, yKoordinaten, 5);
      originalUndBild.append(transformiere(polygon), false);
      originalUndBild.append(transformiere(polygon, aktuelleTransformation), false);
      return originalUndBild;
  }
  
  /**
   * Fuehre eine Translation durch
   * Parameter: umX - in x-Richtung
   *            umY - in y-Richtung
   */
    public void verschiebe(int umX, int umY){
        verberge();
        aktuelleTransformation = new AffineTransform();
        aktuelleTransformation.translate(umX, umY);
        zeige();
    }
  
  /**
   * Fuehre eine Rotation durch
   * Parameter: umWinkel
   *            umX - x-Zentrum
   *            umY - y-Zentrum
   */
    public void rotiere(int umWinkel, int umX, int umY){
        verberge();
        aktuelleTransformation = new AffineTransform();
        aktuelleTransformation.rotate(Math.toRadians(umWinkel), umX, umY); // Aendern !
        zeige();
    }
  
  /**
   * Fuehre eine Streckung durch
   * Parameter: umX - in x-Richtung
   *            umY - in y-Richtung
   */
    public void strecke(double umX, double umY){
        verberge();
        aktuelleTransformation = new AffineTransform();
        aktuelleTransformation.scale(umX , umY);
        zeige();
    }
  
  /**
   * Fuehre eine Scherung durch
   * Parameter: umX - in x-Richtung
   *            umY - in y-Richtung
   */
    public void schere(double umX, double umY){
        verberge();
        aktuelleTransformation = new AffineTransform();
        aktuelleTransformation.shear(umX , umY);
        zeige();
    }
  
  /**
   * Ausgerechnet die Spiegelung geht nicht normal!!!
   * Hier Spiegelung an der Winkelhalbierenden des ersten Quadranten.
   * Die Transformationsmatrix wird spaltenweise eingegeben.
   */
    public void spiegele(){
        verberge();
        aktuelleTransformation = new AffineTransform(0.0, 1.0, 1.0, 0.0, 0.0, 0.0);
        zeige();
    }
  
}
